<template>
  <div class="title">
    <div class="row">
      <div class="col-md-4">
        <h4>Overview</h4>
      </div>
      <!-- <div class="col-md"> -->
      <!-- <button class="btn btn-primary" @click="get_trace_id_list"> Show traces </button> -->
      <!-- </div> -->
      <div class="col-md">
        <select class="form-select" v-model="recent_duration">
          <option disabled value="">Please select one</option>
          <option v-for="key in duration_dict_keys" :value="key">{{ key }}</option>
        </select>
      </div>

      <div class="col-md">
        <select class="form-select" v-model="update_loader">
          <option disabled value="">Please select one</option>
          <option>drex0</option>
          <option>drex1</option>
          <option>drex2</option>
          <option>drex4</option>
          <option>drex6</option>
          <option>drex7</option>
          <option>drex8</option>
        </select>
      </div>

      <div class="col-md">
        <button class="btn btn-primary" @click="update"> {{ update_button_text }} </button>
      </div>
    </div>
    <br />
  </div>

  <div class="table-container">
    <table class="table">
      <thead>
        <tr>
          <th><b>Timestamp</b></th>
          <th><b>Loader</b></th>
          <th><b>Trace</b></th>
          <th><b>Done</b></th>
          <th><b>Search</b></th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(trace, index) in traces" :key="trace.trace" :class="{ 'selected': selected_row === index }"
          @click="selectRow(index)">
          <td>{{ trace.timestamp }}</td>
          <td>{{ trace.loader }}</td>
          <td>{{ trace.trace }}</td>
          <td>{{ trace.done }}</td>
          <td>{{ trace.max_search_step }}</td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
export default {
  data() {
    return {
      traces: [
        { loader: 'drex1', trace: '123' },
        { loader: 'drex1', trace: '456' }
      ],
      selected_row: null,
      selected_trace: null,
      update_loader: 'drex1',
      recent_duration: '1 day',
      duration_dict: {
        '1 day': 1,
        '3 days': 3,
        '1 week': 7,
        '2 weeks': 14,
        '1 month': 31,
        'all': 0,
      },
      hostname: '0.0.0.0',
      update_button_text: 'Pull latest'
    };
  },
  computed: {
    duration_dict_keys() {
      return Object.keys(this.duration_dict);
    }
  },
  methods: {
    selectRow(index) {
      this.selected_row = index;
      this.selected_trace = this.traces[index]
      this.$store.state.trace = this.selected_trace
    },
    update() {
      const request_url = 'http://' + this.hostname + ':8811' + '/update/' + this.update_loader + '/' + this.duration_dict[this.recent_duration]

      this.update_button_text = 'Updating...'
      fetch(request_url)
        .then(response => response.json())
        .then(data => {
          // Do something with the data
          this.traces = data.reverse();
        })
        .catch(error => {
          // Handle any errors
          console.error(error);
        })
        .finally(() => {
          this.update_button_text = 'Pull latest'
        });
    },
    get_trace_id_list() {
      const request_url = 'http://' + this.hostname + ':8811' + '/get-trace-id-list'
      self.selected_row = null
      self.selected_trace = null

      this.$store.commit('increment')
      console.log(this.$store.state.count)

      fetch(request_url)
        .then(response => response.json())
        .then(data => {
          // Do something with the data
          this.traces = data.reverse();
        })
        .catch(error => {
          // Handle any errors
          console.error(error);
        });
    }
  },
  mounted() {
    this.hostname = window.location.hostname;
    this.get_trace_id_list()
  }
};
</script>

<style>
.selected {
  /* background-color: #ccc; */
  background-color: rgb(214, 232, 255);
}

.table-container {
  max-height: 300px;
  /* Set a maximum height */
  overflow-y: auto;
  /* Add a scroll bar if necessary */
}

table {
  /* table-layout: fixed; Fix the table layout */
  width: 100%;
  /* Set the table width to 100% */
}

.title {
  margin-top: 30pt;
}
</style>